use crate::layers::Layers;
use crate::medium::Mediums;
use config::Config;
use serde::Deserialize;
use std::path::Path;

#[derive(Debug, Deserialize)]
pub struct IpOverXConfig {
    pub medium: Mediums,
    pub layers: Vec<Layers>,
}

impl IpOverXConfig {
    pub fn new(path: &Path) -> Result<Self, config::ConfigError> {
        let cfg = Config::builder()
            .add_source(config::File::from(path))
            .build()?;

        cfg.try_deserialize()
    }
}
