use crate::medium::{Medium, ReadMedium, WriteMedium};
use log::info;
use std::io::Read;

#[derive(Clone)]
pub struct Logger;

impl std::io::Write for Logger {
    fn write(&mut self, buf: &[u8]) -> std::io::Result<usize> {
        info!("Outbound Message: {}", pretty_hex::pretty_hex(&buf));

        Ok(buf.len())
    }

    fn flush(&mut self) -> std::io::Result<()> {
        Ok(())
    }
}

impl WriteMedium for Logger {}

impl Read for Logger {
    fn read(&mut self, _buf: &mut [u8]) -> std::io::Result<usize> {
        Ok(0)
    }
}

impl ReadMedium for Logger {}

impl Medium for Logger {
    fn split(&self) -> (Box<dyn ReadMedium>, Box<dyn WriteMedium>) {
        (Box::new(self.clone()), Box::new(self.clone()))
    }

    fn name(&self) -> String {
        "Logger".to_string()
    }
}
